# PromptCraft
A Prompt Perturbation Toolkit for Prompt Robustness Analysis

[![License: MIT](https://img.shields.io/badge/License-MIT-green.svg)](https://opensource.org/licenses/MIT)
[![Made With Love](https://img.shields.io/badge/Made%20With-Love-red.svg)](https://github.com/SuperBruceJia/promptcraft)

## 🗄 Table of Contents
- [Character Editing](#Character-Editing)
  - [Character Replacement](#Character-Replacement)
  - [Character Deletion](#Character-Deletion)
  - [Character Insertion](#Character-Insertion)
  - [Character Swap](#Character-Swap)
  - [Keyboard Typos](#Keyboard-Typos)
  - [Optical Character Recognition (OCR)](#Optical-Character-Recognition)
- [Word Manipulation](#Word-Manipulation)
  - [Synonym Replacement](#Synonym-Replacement)
  - [Word Insertion](#Word-Insertion)
  - [Word Swap](#Word-Swap)
  - [Word Deletion](#Word-Deletion)
  - [Insert Punctuation](#Insert-Punctuation)
  - [Word Split](#Word-Split)
- [Sentence Paraphrasing](#Sentence-Paraphrasing)
  - [Back Translation based on 🤗 Hugging Face MarianMTModel](#Back-Translation-by-Hugging-Face)
  - [Back Translation based on Google Translator](#Back-Translation-by-Google-Translator)
  - [Paraphrasing](#Paraphrasing)
  - [Formal Style](#Formal-Style)
  - [Casual Style](#Casual-Style)
  - [Passive Style](#Passive-Style)
  - [Active Style](#Active-Style)

# 🚀 Installation
```shell
pip install promptcraft
```

# 📝 Preparation
```shell
pip install -r requirements.txt
```

# Character Editing
```python
from promptcraft import CharacterPerturb
```
## Character Replacement
## Character Deletion
## Character Insertion
## Character Swap
## Keyboard Typos
## Optical Character Recognition

# Word Manipulation
```python
from promptcraft import WordPerturb
```
## Synonym Replacement
## Word Insertion
## Word Swap
## Word Deletion
## Insert Punctuation
## Word Split

# Sentence Paraphrasing
```python
from promptcraft import SentencePerturb
```
## Back Translation by Hugging Face
## Back Translation by Google Translator
## Paraphrasing
## Formal Style
## Casual Style
## Passive Style
## Active Style

## 🖼️ Structure of the code
At the root of the project, you will see:

## 🙏 Acknowledgement
This work was finished during my 2023 fall semester research rotation
at the Dependable Computing Laboratory, Department of Electrical and Computer Engineering,
Boston University, under the supervision of Prof. Wenchao Li.
